#red turnip - a modular irc bot written in ruby
#Copyright (C) 2003 cyndis
    
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

require 'config.rb'
require 'copyright.rb'
require 'socket'
require 'irc.rb'
require 'modules.rb'
require 'out.rb'

$Output = Out.new

if ($logging == true and $logging_file != '')
	if ($logging_clear == true)
		$Output.setLoggingClear(true)
	end
	if ($logging_notices == true)
		$Output.setLoggingNotices(true)
	end
	$Output.setLoggingFile($logging_file)
	$Output.setLoggingMode(true)
end

$Output.LoggingInit

$Output.Notice("CORE","Red Turnip started up!")

$modules = BotModules.new($Output)

irc_connection = irc_connect($irc_host,$irc_port)
if (irc_connection != false)
	if (not irc_connection.authenticate($irc_nickname,$irc_ident,$irc_realname))
		$Output.Error("CORE","Could not authenticate!")
		irc_connection.close
		exit
	end
else
	$Output.Error("CORE","Could not connect!")
	exit
end

$modules.setsocket(irc_connection)

$default_modules.each { |x|
	$Output.Debug("CORE","Loaded #{x}")
	require x
}

$modules.GeneralBroadcast('CONNECTED')
$Output.Notice("CORE","Connected")

while (1)
	data = irc_connection.irc_gets
	if (data != false and data != nil)
		if (data.isPing?)
			irc_connection.puts 'PONG :' + data.message.split(':')[1]
		end
		if (data.isRaw?("001"))
			$Output.Notice("CORE","Authenticated")
		end
		$modules.IRCBroadcast(data)
      #$Output.Notice("CORE", data.to_s)
	else
		data = nil
		GC.start
		break
	end
	data = nil
	GC.start
end

$modules.GeneralBroadcast('DISCONNECTED')
$Output.Notice("CORE","Disconnected")

$Output.Notice("CORE","Shutdown")
