class Out
	def initialize
		@log_mode = false
		@log_file = nil
		@log_clear = false
		@log_notices = false
		@log_ready = false
		@sys_ready = true
	end
	def LoggingInit
		begin
			if (@log_clear)
				@log_fp = File.new(@log_file,"w")
			else
				@log_fp = File.new(@log_file,"a")
			end
			@log_ready = true
		rescue
			return false
		end
	end
	# setting functions
	def setLoggingMode(mode)
		@log_mode = mode
	end
	def setLoggingClear(mode)
		@log_clear = mode
	end
	def setLoggingNotices(mode)
		@log_notices = mode
	end
	def setLoggingFile(file)
		@log_file = file
	end
	# logging functions
	def Warning(sector,message)
		if (not @sys_ready)
			return false
		end
		$stderr.puts "!! [#{sector}] " + message
		@log_fp.puts "#{Time.now} [!!/#{sector}] #{message}" if @log_ready
	end
	def Error(sector,message)
		if (not @sys_ready)
			return false
		end	
		$stderr.puts "EE [#{sector}] " + message
		@log_fp.puts "#{Time.now} [EE/#{sector}] #{message}" if @log_ready
	end
	def Notice(sector,message)
		if (not @sys_ready)
			return false
		end	
		$stdout.puts "NN [#{sector}] " + message
		@log_fp.puts "#{Time.now} [NN/#{sector}] #{message}" if @log_notices and @log_ready
	end
	def Debug(sector,message)
		if (not @sys_ready)
			return false
		end
		$stdout.puts "DD [#{sector}] " + message
	end
	def ModuleError(name,message)
		if (not @sys_ready)
			return false
		end
		$stderr.puts "M-EE [#{name}] #{message}"
		@log_fp.puts "#{Time.now} [M-EE/#{name}] #{message}" if @log_ready
	end
	def ModuleWarning(name,message)
		if (not @sys_ready)
			return false
		end
		$stderr.puts "M-!! [#{name}] #{message}"
		@log_fp.puts "#{Time.now} [M-!!/#{name}] #{message}" if @log_ready
	end
	def ModuleNotice(name,message)
		if (not @sys_ready)
			return false
		end
		$stdout.puts "M-NN [#{name}] #{message}"
		@log_fp.puts "#{Time.now} [M-NN/#{name}] #{message}" if @log_notices and @log_ready
	end
end
