#red turnip - a modular irc bot written in ruby
#Copyright (C) 2003 cyndis
    
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

class BotModules
	def initialize(output)
		@classlist = []
		@classnames = []
		@hostcalls = []
		@disabled = []
		@usermodule = nil
		@Output = output
		return true
	end
	def setsocket(socket)
		@socket = socket
	end
	def GeneralBroadcast(message)
		res = true
		threads = []
		begin
			@classlist.each { |x|
				if (@disabled.include?(x))
					next
				end
					if (x.GeneralMessage(message) == 'HALTDEF')
						break
					end
			}
			res = true
		rescue
			res = false
		end
		return res
	end
	def ModuleMessage(message,modcode)
		res = true
		begin
			if (@classlist.include?(modcode) and !@disabled.include?(modcode))
				@classlist[@classlist.index(modcode)].ModuleMessage(message)
			else
				res = true
			end
		rescue
			res = false
		end
		return res
	end
	def ModuleBroadcast(message)
		res = true
		begin
			@classlist.each { |x|
				if (@disabled.include?(x))
					next
				end
				x.ModuleMessage(message)
			}
			res = true
		rescue
			res = false
		end
		return res
	end
	def IRCBroadcast(message)
		res = true
		begin
			@classlist.each { |x|
				if (@disabled.include?(x))
					next
				end
					if (x.IRCMessage(message) == 'HALTDEF')
						break
					end
			}
			res = true
		rescue
			res = false
		end
		message = nil
		return res
	end
	def addHostCall(message)
		@hostcalls.push(message)
	end
	def newestCall
		return @hostcalls[@hostcalls.length]
	end
	def loadedModules?
		return @classlist
	end
	def disableModule(modcode)
		if (@classlist.include?(modcode))
			@disabled.push(modcode)
			return true
		end
		return false
	end
	def enableModule(modcode)
		if (@disabled.include?(modcode))
			@disabled.delete(modcode)
			return true
		end
		return false
	end
	def disabledModules?
		return @disabled
	end
	def loadModule(classinstance)
		classname = classinstance.getModuleName
		if (@classnames.include?(classname))
			@classlist.delete_at(@classnames.index(classname))
			@classnames.delete_at(@classnames.index(classname))
		end
		if (not classinstance.respond_to?(:instantRelease?) or not classinstance.instantRelease?)
			@classlist.push(classinstance)
			@classnames.push(classname)
			@classlist[@classlist.index(classinstance)].data(@socket,@Output,self)
		end
		if (classinstance.instantRelease?)
			classinstance.data(@socket,@Output,self)
			@Output.Notice "MODULES","Module #{classname} requested instant release"
			classinstance = nil # hope this frees it
		end
		@Output.Notice "MODULES","Module #{classname} loaded!"
	end
	def moduleNames?
		return @classnames
	end
	def moduleExists?(name)
		return (@classnames.include?(name) ? true : false)
	end
	def userModule
		return @usermodule
	end
end
